<?php
namespace Newland\Toubiz\Sync\Neos\Domain\Model;

/*
 * This file is part of the "toubiz-sync-neos" package.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 */

use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use Neos\Flow\Annotations as Flow;
use Newland\Toubiz\Api\ObjectAdapter\Concern\TransportationFacilityConstants;

/**
 * @Flow\Entity
 * @ORM\Table(indexes={
 *      @ORM\Index(name="newland_toubiz_sync_neos_transportationfacility_import_ident", columns={"originalid"})
 * })
 * @deprecated This model will be removed in the future.
 */
class TransportationFacility extends AbstractEntity implements TransportationFacilityConstants
{
    /**
     * @ORM\ManyToMany(
     *     targetEntity="Newland\Toubiz\Sync\Neos\Domain\Model\Region",
     *     mappedBy="transportationFacilities", fetch="LAZY"
     * )
     * @var Collection<int, Region>
     */
    protected $regions;

    /**
     * @var string
     */
    protected $name;

    /**
     * @var int
     */
    protected $type;

    /**
     * @var int
     */
    protected $status;

    /**
     * @var int
     * @ORM\Column(nullable=true)
     */
    protected $length;

    /**
     * @var int
     * @ORM\Column(nullable=true)
     */
    protected $travelTime;

    /**
     * @var \DateTime
     */
    protected $updatedAt;

    /**
     * Class constructor.
     *
     * This constructor is called before hydration and dependency
     * injection is happening.
     *
     * @return void
     */
    public function __construct()
    {
        $this->regions = new ArrayCollection;
    }

    /**
     * Logical check if a facility is open.
     *
     * @return bool
     */
    public function getIsOpen()
    {
        return in_array($this->status, self::DEFINITION_STATUS_OPEN, true);
    }

    /**
     * @param string $name
     * @return void
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param int $type
     * @return void
     */
    public function setType($type)
    {
        $this->type = $type;
    }

    /**
     * @return int
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * @param int $status
     * @return void
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }

    /**
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * @param int $length
     * @return void
     */
    public function setLength($length)
    {
        $this->length = $length;
    }

    /**
     * @return int
     */
    public function getLength()
    {
        return $this->length;
    }

    /**
     * @param int $travelTime
     * @return void
     */
    public function setTravelTime($travelTime)
    {
        $this->travelTime = $travelTime;
    }

    /**
     * @return int
     */
    public function getTravelTime()
    {
        return $this->travelTime;
    }

    /**
     * @param \DateTime $updatedAt
     * @return void
     */
    public function setUpdatedAt($updatedAt)
    {
        $this->updatedAt = $updatedAt;
    }

    /**
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->updatedAt;
    }
}
